function try_add_gui(player_index, entity_list)
  local player = game.players[player_index]
  if not (player.gui.left.de_frame) then
    add_gui(player_index, entity_list)
  end
end

function add_gui(player_index, entity_list)
  local player = game.players[player_index]
  -- local frame = player.gui.left.add{type = "frame", name = "de_frame", direction = "horizontal", style = "naked_frame_style"} -- 0.15
  local frame = player.gui.left.add{type = "frame", name = "de_frame", direction = "horizontal", style = "naked_frame"} -- 0.16
  for i, entity_name in pairs (entity_list) do
    frame.add({
      type = "sprite-button",
      name = 'de_' .. entity_name,
      -- style = "slot_button_style", -- 0.15
      style = "slot_button", -- 0.16
      -- style = "not_available_slot_button_style",
      sprite  = "item/" .. entity_name,
      tooltip = (game.item_prototypes[entity_name].localised_name)
    })
   end
   -- close button
   -- frame.add({type = "button", name = 'de_' .. 'X', caption = "x", style = "button"})
   -- frame.add({type = "button", name = 'de_' .. 'X', caption = "x", style = "flip_button_left"}) -- too little
   -- frame.add({type = "button", name = 'de_' .. 'X', caption = "x", style = "flip_button_right"}) -- too little
   -- frame.add({type = "button", name = 'de_' .. 'X', caption = "x", style = "flip_button_middle"}) -- too little
   -- frame.add({type = "button", name = 'de_' .. 'X', caption = "x", style = "fake_disabled_button"}) -- too big, gray only
   -- frame.add({type = "button", name = 'de_' .. 'X', caption = "x", style = "dialog_button"}) -- too width
   -- frame.add({type = "button", name = 'de_' .. 'X', caption = "x", style = "play_tutorial_button"}) -- nice one!
   frame.add({type = "button", name = 'de_' .. 'X', caption = "x", style = "play_completed_tutorial_button"})  -- nice one! Half transperent
   
   printAll("Disable Entities: GUI for " .. player.name)
end

function delete_gui(player_index)
  local player = game.players[player_index]
  player.gui.left.de_frame.destroy()
   -- printAll("Disable Entities: GUI for " .. player.name)
end

function change_button_color(player, entity_name)
  local button_name = "de_" .. entity_name
  if (global.states[entity_name]) then
    -- player.gui.left["de_frame"][button_name].style = "slot_button_style" -- 0.15
    player.gui.left["de_frame"][button_name].style = "slot_button" -- 0.16
    --global.roboport.enabled = false
  else
    -- player.gui.left["de_frame"][button_name].style = "not_available_slot_button_style" -- 0.15
    player.gui.left["de_frame"][button_name].style = "not_available_slot_button" -- 0.16
    --global.roboport.enabled = true
  end
end

function printAll(text)
	-- log (text)
	for player_index, player in pairs (game.players) do
		game.players[player_index].print (text)
	end
end
