script.on_init(function ()
  try_init ()
end)

function try_init ()
  if not global then global = {} end
  if not global.vehicles then global.vehicles = {} end
  if not global.vehicle_id then global.vehicle_id = 0 end
  -- local entities = game.surfaces[1].find_entities_filtered{type= 'car'}
  local entities = game.surfaces[1].find_entities_filtered{type = {'car', 'locomotive'}}
  for i, entity in pairs (entities) do
    table.insert (global.vehicles, {entity = entity, mileage = 0, last_position ={x=entity.position.x, y=entity.position.y}, type = entity.type, unit_number = entity.unit_number, first_tick = game.tick})
  end
  
  -- entities = game.surfaces[1].find_entities_filtered{type= 'locomotive'} -- we don't need that!
  -- for i, entity in pairs (entities) do
    -- table.insert (global.vehicles, {entity = entity, mileage = 0, last_position ={x=entity.position.x, y=entity.position.y}, type = entity.type, unit_number = entity.unit_number, first_tick = game.tick})
  -- end
end

script.on_event(defines.events.on_built_entity, function (event)
  local entity = event.created_entity
  if entity.type == 'locomotive' or entity.type == 'car' then
    table.insert (global.vehicles, {entity = entity, mileage = 0, last_position ={x=entity.position.x, y=entity.position.y}, type = entity.type, unit_number = entity.unit_number, first_tick = game.tick})
    game.players[1].print ('Added vehicle: '..serpent.line (global))
  end
end)

script.on_event(defines.events.on_tick, function(event)
  local amount = #global.vehicles
  local id = global.vehicle_id
  if (amount == 0) then return end
  if id > amount then id = 1 end
  local vehicle = global.vehicles[id]
  if vehicle then
    local entity = vehicle.entity
    if not(entity) or (not (entity.valid)) then
      log (vehicle.type ..' -  vehicle #'..id..' - mileage:'..vehicle.mileage)
      table.remove (global.vehicles, id)
      return
    end
    update_mileage (vehicle)
  end
  global.vehicle_id = id + 1
end)

function update_mileage (vehicle)
  local old_x = vehicle.last_position.x
  local old_y = vehicle.last_position.y
  local new_x = vehicle.entity.position.x
  local new_y = vehicle.entity.position.y
  local track = ((old_x-new_x)^2 + (old_y-new_y)^2)^0.5
  vehicle.mileage = vehicle.mileage + track
    -- if not (old_x==new_x) then game.players[1].print ('Old position: x='..old_x..' y='..old_y.. '; new_position: x='..new_x..' y='..new_y..' track: '..track..' mileage: '..vehicle.mileage) end
  vehicle.last_position = {x=new_x, y=new_y}
end

-- on_player_driving_changed_state
script.on_event(defines.events.on_player_driving_changed_state, function (event)
  local player_index = event.player_index
  local entity = event.entity
  if entity then
    local unit_number = entity.unit_number
    local id = get_vehicle_by_unit_number (unit_number)
    if id then
      local vehicle = global.vehicles[id]
      -- game.players[player_index].print (serpent.line (vehicle))
      game.players[player_index].print ('Vehicle #'.. id ..' type: '..vehicle.type..' has mileage: '..math.floor(vehicle.mileage))
      
    end
  end
end)

function get_vehicle_by_unit_number (unit_number)
  for id, vehicle in pairs (global.vehicles) do
    if vehicle.entity.unit_number == unit_number then
      return id
    end
  end
  return false
end